comment "-------------------------------------------------------------------------------------------------------";
comment "											indiCam, by woofer.											";
comment "																										";
comment "										independent cinematic camera									";
comment "																										";
comment "																										";
comment "	The purpose of the init is to compile all functions and set all variables from start.				";
comment "																										";
comment "																										";
comment "	Definitions:																						";
comment "	- Scene: A predefined camera angle with camera movement along with take time, fov and so on.		";
comment "	- Variable names: indiCam_var_variableName															";
comment "	- Function and script names: indiCam_fnc_functionOrScriptName(.sqf)									";
comment "	- Object names: indiCam_objectName																	";
comment "																										";
comment "-------------------------------------------------------------------------------------------------------";
// Versioning: Significant new functionality adds to the tenth of a version, scene additions and fixes adds to the hundreds


/* Changelog version 1.3*/	
comment " PRIORITIES / DONE ";
/*
Complete redesign of the core scripts have been made. No script was left untouched and most got re-written from scratch.

Major redesign of camera movement system has been done as well. It now gets calculated on each frame to alleviate jitter as much as possible. That means that all the old scenes were wiped and I have started to create new ones. There is a basic set of scenes in and I will add more as I manage to get them stable and smooth enough. The upside is that switching scenes and actors are a whole lot more stable.

The second large addition is the new system that detects special events and cuts to a scene to show that. The only one implemented just yet is the detection of launcher usage by a unit.
*/

//REMOVED- The number of scenes are now back to only a few due to core rewrite. Future releases will see more of them added back in the new system.
//ADDED- Actor auto switching added to gui with controls for duration and nine different modes.
//ADDED- If a player is the current actor, that player will be selected in player list upon loading the gui
//ADDED- Made the player list in gui display what side each player is on. Runs out of space real fast though.
//ADDED- Automatic night vision will now take terrain and current date into account and turn on half an hour after sunset and turn off half an hour before sunrise
//ADDED- Made actor deaths handeled by the scripted scene system and more reliable.
//ADDED- Manual mode added to gui.
//ADDED- Slider in GUI: Chance of capture cinematic scenes upon detection (0-100%). Zero means off.
//ADDED- The initial drop-down selection on map side will be whatever side the player is.
//ADDED- Pressing F9 during camera will now also store the scene name in a list. Going out of the camera immediately after pressing F9 will list the contents in a hint. Good for finding scenes that aren't working.
//ADDED- barrelWatch scene which will track barrel direction. Only for tanks for now.
//FIXED- GUI now looks as intended in both the script and the mod version. Thanks Taro!
//FIXED- Actor death now takes actor auto switch setting into account.
//FIXED- Units of any side can now be selected on the gui map.
//FIXED- Scene override timer now works in scripted version without gui.
//FIXED- Eventhandlers weren't removed from non-actor units in a controlled fashion
//FIXED- Changed wording of gui elements and tooltips for some controls.
//FIXED- Updated diary with information on GUI.
//FIXED- Start button could be pressed repeatedly and launch several instances of the camera.
//FIXED- Settings changed in gui will now be applied even if the camera isn't already running.
//FIXED- Culled a whole lot of unused code.
//FIXED- When debug was on it spawned the indicator spheres on every client.
//FIXED- indiCam settings window could be shown ontop of regular map which caused issues with cursor and markers
//FIXED- If there is only one unit (the player) on a terrain, the camera will not find eligable actors and try to switch actor indefinitly
//FIXED- An occational CTD when calculating too large or small movement values after switching actors.

comment " SCRIPTED SCENES ";
//TODO- Add "killer" as scripted scene as a death scene. Could be made to be shown on every occation in GUI.
//TODO- Detect incoming mortar fire and switch to show an overview of the location at impact
//TODO- Soemthing weird with launcherScan sometimes. It's like it's being looped endlessly on having an AT actor on cooldown

comment " BACKLOG ";
//TODO- F3 should reset auto switch timer for actor
//TODO- When a player actor enters a vehicle, the camera autoswitches according to current settings.
//TODO- When the AT script is activated, it should keep a lookout if the unit puts the AT back.
//TODO- Make names of players show in GUI map
//TODO- Need a way to track a specific actor through death again.
//TODO- Make sure the camera keeps following actors after death.
//TODO- Would be totally cool with a flashlight type function as with Zeus or the editor. Maybe spawn a local light above the actor?
//TODO- Might need to spawn a background function that keeps track of indiCam_running variable
//TODO- How do the new special scene actor stuff work alongside unconcious units with ace or reggs script?
//TODO- Scripted scenes that makes jumps to close-by animals
//TODO- Make a scene switch if the camera is stuck to the ground for too long
//TODO- Preventing scene switching doesn't seem to prevent scene switching by obscured actor.
//TODO- Add proximity to enemies as a way to elevate the action value in situation check
//TODO- Moving value should maybe be used to stay on at least action value 1 in situation check
//TODO- Maybe should spawn several different action system checks that can work independently in situation check
//TODO- Scripted scene: Keep track of air assets when they have low velocity < 70 and are close to ground (< 10m) or when they are in the AO
//TODO- When using the randomize actor starting out from a civilian actor, the result might be an agent
//TODO- Add a good looking text that pops up on screen for a short time each time the actor was changed. gui: ["OFF", "TEMPORARY", "PERMANENT"]
//TODO- Add "persistent actor" function if that's not already in by default by selecting "none" in randomizer. It would then need something else to do while respawning and come back to the same player unit after respawn.
//TODO- Player selection list in dialogControl might need a refresh button. Now the user has to restart the dialog entirely.
//TODO- Make indiCam_fnc_distanceSort function test if proper params were passed.
//TODO- Add cleanup script that waits for the camera to close. Should make for a more stable cleanup if the main scripts gets interrupted
//TODO- Check to see if we can detect weapon switching. That would help with camera views on vehicles (compare current ammo to weapon type?)
//TODO- Rewrite game logics according to the new method used in randomLinear ro remove dependency on the logic objects.
//TODO- Make vehicles and aircraft detect shooting scenes with either a single fire category or by actionLevel
//TODO- Now that I have the environmentCheck I may want to add disqualification with something like (_urbanBool) then {find a new scene};
//TODO- Add indiCam_var_proximityValue functionality to situationCheck
//TODO- Add indiCam_var_movingValue functionality to situationCheck
//TODO- New scene: One that starts away from the actor and then uses cameraLogic to reduce distance in a non-linear manner
//TODO- New scene: groundCam - Human perspective of aircraft going by. Camera stationary at 1.8m
//TODO- New scene: randomWideFar - Randomized, long range, stationary shots with wide fov.
//TODO- New scene: weaponPerson - This would be the weaponCam, I guess. I'd love to get this to work
//TODO- New scene: linearPanCam - Camera that pans linearly while targeting the infrontLogic
//TODO- New scene: curvePanCam - Camera that pans non-linearly while targeting the infrontLogic
//TODO- New scene: groupCam - A camera that takes an entire squad into shot. Maybe maxDistance can be used to keep it in line if one member is half a world away. Check worldToScreen.
//TODO- New scene: Weapon cam tank/helo - attached right above or below the vic and rotating along with main barrel
//TODO- New scene: Infront logic combined with a camera attached above the rear of a tank


//OPINION- Tankbuster: fixed-wing, a camera 'bolted' to the top of the tailplane looking forward, or close to a weapon pylon. Perhaps it could switch near pylon/gun when player changes fire mode?
//OPINION- Land vehicles, when the player is in a Prowler, for example, a camera bolted to the roll cage would be funky.


//IDEA- "Roving mode" that doesn't make cuts, but simply moves the camera.
//IDEA- ADD CBA keybinds? Important that the script stays mod agnostic
//IDEA- ADD CBA mod settings? Important that the script stays mod agnostic, so maybe not
//IDEA- A more obvious indicator for when the camera is running. Perhaps a color indicator?
//IDEA- Make indiCam automatically look for other players on the server at startup and set one as actor. If no other players are there, set player as actor.
//IDEA- Add to GUI: indiCam_var_hiddenActorTime = 4; // Seconds to allow the actor to be hidden before switching scene unless indiCam_var_ignoreHiddenActor is true
//IDEA- Investigate "createSimpleObject/objects" if it's something that's better to use for logics
//IDEA- Maybe build a "transition" part between scenes, so that each scene can define how to go into it - sort of like with the different camera commits
//IDEA- A follow logic that tracks exactly where the actor stepped. That way it can follow through doors
//IDEA- Let advanced users override the onboard sceneSelect for a userconfig version.
//IDEA- Add ability to suspend the automatic switching of scenes at least through script. Would not top LOS switching.
//IDEA- Keep track of actor taking damage, up the action when that happens
//IDEA- Add camera control for other players. Maybe by broadcasting a variable containing connection ID or having a user grab the cameraman ID.
//IDEA- Add the possibility for the camera to follow objects around that has object name starting with indiCam_baton* in it's inventory
//IDEA- Maybe I should convert the main loop's interrupt to a function that I can call wherever?
//IDEA- Let any player walk up to the cameraman and action menu himself a set of addactions controls. that way we can send the vars to the correct connection id.
//IDEA- Is it possible to keep the follow logics away from buildings? Would help with LOS stuff
//IDEA- Maybe add a counter to sceneSelect so that the next scene test only tries a set number of times before waiting a little while before trying again.
//IDEA- How to stream the camera input to only an HUD element? Problem is camera commit. Maybe if the camera is created but not started it will work just fine? See KK's blog.
//IDEA- Can I get the camera to switch to first person view? Like when in a vic. Problem is recording will contain same perspective at times.
//IDEA- I need a way to know if an actor is on screen. some scenes are badly trimmed in. Maybe use worldToScreen?
//IDEA- A scene that checks for building windows around the actor and attempts to look through from the inside.
//IDEA- Maybe use something like {_justPlayers = allPlayers - entities "HeadlessClient_F";} to find players instead of what's used now


comment "-------------------------------------------------------------------------------------------------------";
comment "													init												";
comment "-------------------------------------------------------------------------------------------------------";
// indiCam script should only init on player clients or on player hosts.
if (hasInterface) then {
	
	// Player is now either not spawned or has died
	waitUntil {alive player};
	
	indiCam_actor = player;
	
	// Read up on all the hottest settings
	// Execute this during camera operation to reset to normal
	_settings = [] execVM "INDICAM\indiCam_core_settings.sqf";
	waitUntil {scriptDone _settings};
	
	
	// initialize the graphical user interface
	[] execVM "INDICAM\indiCam_gui\indiCam_gui_init.sqf";
	
	
	// Initialize running modes - possible modes are [default, interrupt, scripted, manual, off]
	indiCam_var_requestMode = "off";
	indiCam_var_currentMode = "off";
	indiCam_running = false;
	
	// Initialize the diary entry
	[] execVM "INDICAM\indiCam_core_diary.sqf";
	
	
comment "-------------------------------------------------------------------------------------------------------";
comment "												variables												";
comment "-------------------------------------------------------------------------------------------------------";
	// Actor management
	indiCam_var_enterVehicleEH = 0;				// Eventhandler for actorManager
	indiCam_var_exitVehicleEH = 0;				// Eventhandler for actorManager
	indiCam_var_actorFiredEH = 0;				// Eventhandler for actorManager
	indiCam_var_actorDeletedEH = 0;				// Eventhandler for actorManager
	indiCam_var_actorKilledEH = 0;				// Eventhandler for actorManager
	indiCam_var_actorAutoSwitch = false;
	
	
	// Initialize switching timers
	indiCam_var_sceneTimer = time + 9999999;
	indiCam_var_actorTimer = time + 9999999;
	indiCam_var_sceneSelectRunning = false;
	
	// Camera variables
	indiCam_var_activeEventHandlers = [];
	
	// More variables
	indiCam_var_mapselectAll = false;
	indiCam_var_mapOpened = false;
	indiCam_var_sceneList = [];
	indiCam_var_actionValue = 0;
	
	// Scene selection
	indiCam_var_scene = "";
	indiCam_var_sceneType = "";
	indiCam_var_previousScene = "none";
	
	indiCam_var_takeTime = 30;
	indiCam_var_cameraMovementRate = 0.5;
	indiCam_var_cameraPos = (getPos player);
	indiCam_var_targetPos = (getPos player);
	indiCam_var_cameraSpeed = 1;
	indiCam_var_targetSpeed = 1;
	indiCam_var_cameraTarget = player;
	indiCam_var_cameraTargetScripted = player;
	indiCam_var_cameraFov = 0.74;
	indiCam_var_maxDistance = 5000;
	indiCam_var_ignoreHiddenActor = false;
	indiCam_var_cameraType = "";
	indiCam_var_sceneHold = false;
	
	indiCam_appliedVar_takeTime = indiCam_var_takeTime;
	indiCam_appliedVar_cameraMovementRate = indiCam_var_cameraMovementRate;
	indiCam_appliedVar_cameraPos = indiCam_var_cameraPos;
	indiCam_appliedVar_targetPos = indiCam_var_targetPos;
	indiCam_appliedVar_cameraSpeed = indiCam_var_cameraSpeed;
	indiCam_appliedVar_targetSpeed = indiCam_var_targetSpeed;
	indiCam_appliedVar_cameraTarget = indiCam_var_cameraTarget;
	indiCam_appliedVar_cameraTargetScripted = indiCam_var_cameraTargetScripted;
	indiCam_appliedVar_cameraFov = indiCam_var_cameraFov;
	indiCam_appliedVar_maxDistance = indiCam_var_maxDistance;
	indiCam_appliedVar_ignoreHiddenActor = indiCam_var_ignoreHiddenActor;
	indiCam_appliedVar_cameraType = indiCam_var_cameraType;
	
	// Advanced scene scripts
	indiCam_scene_scriptedScene = {};
	indiCam_var_scriptedSceneRunning = false;
	indiCam_var_scriptedSceneType = "";
	indiCam_var_unitCooldown = [];
	indiCam_var_tempPos = [0,0,0];
	indiCam_var_launcherScanArray = [];
	
	// GUI controls
	indiCam_var_checkBoxOverride = false;
	indiCam_var_durationOverride = 30;
	indiCam_var_actorAutoSwitchCheckboxState = false;
	
	indiCam_var_SceneOverrideState = false;
	indiCam_var_guiSceneOverrideDuration = 30;
	indiCam_var_sceneSwitch = true;

comment "-------------------------------------------------------------------------------------------------------";
comment "												functions												";
comment "-------------------------------------------------------------------------------------------------------";
	// Compile functions as a function. Makes it possible to compile on the fly
	indiCam_fnc_compileAll = {
		indiCam_core_main = compile preprocessFileLineNumbers "INDICAM\indiCam_core_main.sqf";
		indiCam_core_mainLoop = compile preprocessFileLineNumbers "INDICAM\indiCam_core_mainLoop.sqf";
		indiCam_core_inputControls = compile preprocessFileLineNumbers "INDICAM\indiCam_core_inputControls.sqf";
		
		indiCam_fnc_sceneTest = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_sceneTest.sqf";
		indiCam_fnc_actorSwitch = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_actorSwitch.sqf";
		indiCam_fnc_actorList = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_actorList.sqf";
		indiCam_fnc_distanceSort = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_distanceSort.sqf";
		indiCam_fnc_situationCheck = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_situationCheck.sqf";
		indiCam_fnc_visibilityCheck = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_visibilityCheck.sqf";
		indiCam_fnc_environmentCheck = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_environmentCheck.sqf";
		indiCam_fnc_visionMode = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_visionMode.sqf";
		indiCam_fnc_launcherScan = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_launcherScan.sqf";
		indiCam_fnc_unitCooldown = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_unitCooldown.sqf";
		indiCam_fnc_followLogicFPS = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_followLogicFPS.sqf";
		indiCam_fnc_followLogicTurretAim = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_followLogicTurretAim.sqf";
		indiCam_fnc_twopointLOS = compile preprocessFileLineNumbers "INDICAM\functions\indiCam_fnc_twopointLOS.sqf";
		
		indiCam_scene_selectMain = compile preprocessFileLineNumbers "INDICAM\scenes\indiCam_scene_selectMain.sqf";
		indiCam_scene_selectScripted = compile preprocessFileLineNumbers "INDICAM\scenes\indiCam_scene_selectScripted.sqf";
		indiCam_scene_mainBoat = compile preprocessFileLineNumbers "INDICAM\scenes\indiCam_scene_mainBoat.sqf";
		indiCam_scene_mainCar = compile preprocessFileLineNumbers "INDICAM\scenes\indiCam_scene_mainCar.sqf";
		indiCam_scene_mainFoot = compile preprocessFileLineNumbers "INDICAM\scenes\indiCam_scene_mainFoot.sqf";
		indiCam_scene_mainHelicopter = compile preprocessFileLineNumbers "INDICAM\scenes\indiCam_scene_mainHelicopter.sqf";
		indiCam_scene_mainPlane = compile preprocessFileLineNumbers "INDICAM\scenes\indiCam_scene_mainPlane.sqf";
		indiCam_scene_mainTank = compile preprocessFileLineNumbers "INDICAM\scenes\indiCam_scene_mainTank.sqf";
		
		if (indiCam_debug) then {systemChat "-- scripts compiled --"};
	};
	[] call indiCam_fnc_compileAll;
	
	// Set the player as the initial actor by calling the actor switch script thereby setting the proper eventhandlers
	// Always use this script to set a new actor. Don't use the regular actor for scripted scenes.
	[player] call indiCam_fnc_actorSwitch;
	
	
	// This function removes eventhandlers of certain types stored in the global variable
	indiCam_fnc_clearEventhandlers = {
		while { !(indiCam_var_activeEventHandlers isEqualTo []) } do {	// This extra while loop ensures array is empty
			{
				[_x, "onEachFrame"] call BIS_fnc_removeStackedEventHandler;
				indiCam_var_activeEventHandlers = indiCam_var_activeEventHandlers - [_x];
			} forEach indiCam_var_activeEventHandlers;
		};

	};
	
	
	// Give the player the option to start indiCam UI
	// Currently temporary. Make a script that makes sure that the player has these on him even after remoting with AIC
	player addAction ["indiCam", "_handle=createdialog 'indiCam_gui_dialogMain'"];
	

}; // End of hasInterface