// Attempt at another flight operations script for the ambiance 3 module
// We assume that the player did not alter plane positions too much or did not add new planes 
// in the middle of the flightdeck

#define WHITE 0
#define YELLOW 1
#define GREEN 2
#define GRAPE 3
#define RED 4
#define BLUE 5
#define BROWN 6
#define SOLDIER 7
#define PILOT 8

ttt_nimitz_soldierTypes = [] call ttt_fnc_soldierTypes;

// there is a resource exhaustion possible, handle with care
ttt_nimitz_fnc_callsign = {
	params ["_carrier"];
    private ["_nim", "_list", "_callsign"];

    private _list = 
			  ["Bear", "Wolf", "Wedge", "Lightning", "Tango", "Boston", "Merlin",
               "Doc", "Chaos", "Ranger", "Alien", "Bacon", "Toon", "Slick", 
    	       "Bigfoot", "Tonto", "Gizmo", "Alpo", "Scotty"];
    // ATTENTION: when 100 names are used per base callsign, any callsign returned will be Vader
    private _callsign = "";
    private _i = 0;
    while {_callsign isEqualTo ""} do {
    	if (_i > 99) exitWith {
    		_callsign = "Vader";
    	};
    	private _baseCallsign = selectRandom _list;
    	_callsign = format ["%1-%2", _baseCallsign, floor random 100];
    	if (_callsign in (_carrier getVariable ["ttt_nimitz_assignedCallsigns", []])) then {
    		_callsign = "";
    	} else {
		    private _assignedCallsigns = _carrier getVariable  ["ttt_nimitz_assignedCallsigns", []];
		    _assignedCallsigns pushBack _callsign;
			_carrier setVariable ["ttt_nimitz_assignedCallsigns", _assignedCallsigns];
	    };
	    _i = _i + 1;
    };

    _callsign;	
};


ttt_nimitz_planes_air_all = nearestObjects [Nimitz, ["Plane"], 30000];
ttt_nimitz_planes_air = [];
{
	if (typeOf _x isEqualTo "jdg_shuttle") then {
		// ignore
	} else {
		ttt_nimitz_planes_air pushBack _x;
	};
} forEach ttt_nimitz_planes_air_all;

{
	private _callsign = [Nimitz] call ttt_nimitz_fnc_callsign;
	(group driver _x) setGroupId [_callsign];
	_x setVariable ["ttt_nimitz_callsign", _callsign];
	// systemChat format ["Assigned plane %1", _x];
} forEach ttt_nimitz_planes_air;
ttt_nimitz_turn = [];
ttt_nimitz_taxi = [];

[ "ttt_nimitz_000", "onEachFrame", 
  {
  	{
  		private _plane = _x;
  		private _add = _plane getVariable "ttt_nimitz_add";
  		private _dir = _plane getVariable "ttt_nimitz_dir";

  		_plane setDir ((getDir _plane) + _add);

  		if (floor getDir _plane == floor _dir) then {
  			_plane setDir _dir;
  			ttt_nimitz_turn = ttt_nimitz_turn - [_plane];
  			_plane setVariable ["ttt_nimitz_add", nil];
  			_plane setVariable ["ttt_nimitz_dir", nil];
  		};
	} forEach (missionNamespace getVariable ["ttt_nimitz_turn", []]);
	{
		private _plane = _x;
		private _pos = _plane getVariable "ttt_nimitz_pos";
		private _sleep = _plane getVariable "ttt_nimitz_sleep";
		private _pos2 = _plane getPos [1, getDir _plane];
		_pos2 set [2, getPosASL _plane # 2];
		_plane setVelocityTransformation
		[
			getPosASL _plane,
			_pos2,
			[0, 0, 0],
			[0, 0, 0],
			vectorDir _plane,
			vectorDir _plane,
			[0, 0, 1],
			[0, 0, 1],
			0.1
		];
		if (_plane getRelDir _pos > 90 and _plane getRelDir _pos < 270) then {
			// systemChat format ["relDir: %1", _plane getRelDir _pos];
			_plane setVariable ["ttt_nimitz_pos", nil];
			_plane setVariable ["ttt_nimitz_sleep", nil];
			ttt_nimitz_taxi = ttt_nimitz_taxi - [ _plane ];
		};
	} foreach (missionNamespace getVariable ["ttt_nimitz_taxi", []]);
  }
] call BIS_fnc_addStackedEventHandler;





ttt_nimitz_fnc_fly = {
	params ["_carrier"];

	_carrier setVariable ["ttt_nimitz_landing", false];

	private _nimspots = _carrier getVariable "nimspots";
	private _E4 = _nimspots modelToWorld (_nimspots selectionPosition "E4");

	private _sar = _E4 nearestObject "Helicopter";
	private _pos1 = _carrier getPos [1000, getDir _carrier - 90];
	private _pos2 = _pos1 getPos [2000, getDir _carrier - 180];
	[_sar, _pos1, _pos2] spawn ttt_nimitz_fnc_flySAR; 

	// wait for SAR to be airborne
	waitUntil {alive _carrier and _sar distance _carrier > 100};
	private _C3 = _nimspots modelToWorld (_nimspots selectionPosition "C3");
	private _e4plane = _E4 nearestObject "Plane";
	[_carrier, _e4plane, _C3, 3] spawn ttt_nimitz_fnc_taxiAndTakeoff;

	private _C1 = _nimspots modelToWorld (_nimspots selectionPosition "C1");
	private _C2 = _nimspots modelToWorld (_nimspots selectionPosition "C2");
	private _c1plane1 = _C1 nearestObject "Plane";
	[_carrier, _c1plane1, _C2, 2] spawn ttt_nimitz_fnc_taxiAndTakeoff;

	// wait for plane closest to Cat 1 is no longer first plane to start from C1
	waitUntil { alive _carrier and _C1 nearestObject "Plane" != _c1plane1 };
	sleep 5;
	private _c1plane2 = _C1 nearestObject "Plane";
	[_carrier, _c1plane2, _C1, 1] spawn ttt_nimitz_fnc_taxiAndTakeoff;

    // wait for plane from elevator 4 to be airborne
	waitUntil { alive _carrier and alive _e4plane and _e4plane distance _carrier > 200 };
	private _E3 = _nimspots modelToWorld (_nimspots selectionPosition "E3");
	private _C4 = _nimspots modelToWorld (_nimspots selectionPosition "C4");
	private _e3plane = _E3 nearestObject "Plane";
	[_carrier, _e3plane, _C4, 4] spawn ttt_nimitz_fnc_taxiAndTakeoff;

	// start all other flight deck planes
	waitUntil {alive _carrier and alive _e3plane and _e3plane distance _carrier > 200};
	private _allPlanes = nearestObjects [_C3, ["Plane"], 150];
	// only take flightdeck planes
	private _cat = [ [_C3, 3], [_C4, 4] ];
	{
		if (getPosASL _x # 2 > 15) then {
			private _catToUse = selectRandom _cat;
			[_carrier, _x, _catToUse # 0, _catToUse # 1] spawn ttt_nimitz_fnc_taxiAndTakeoff;
			waitUntil {alive _carrier and alive _x and _x distance _carrier > 200};
		};
	} forEach _allPlanes;

	_carrier setVariable ["ttt_nimitz_landing", true];

	_carrier;
};


ttt_nimitz_fnc_turn = {
	params ["_plane", "_dir"];

	private _origDir = getDir _plane;
	if (_dir >= 360) then {
		systemChat "Warning: Turn may go wrong, dir >= 360";
	};
	if (_dir < 0) then {
		systemChat "Warning: Turn may go wrong, dir < 0";
	};
	private _add = -0.2;
	if (_origDir <= 180) then {
		if (_dir > _origDir and _dir <= _origDir + 180) then {
			_add = 0.2;
		};
	} else {
		_add = 0.2;
		if (_dir < _origDir and _dir >= _origDir - 180) then {
			_add = -0.2;
		};
	};
	_plane setVariable ["ttt_nimitz_add", _add];
	_plane setVariable ["ttt_nimitz_dir", _dir];
	ttt_nimitz_turn pushBackUnique _plane;

	// add is either 0.2 or -0.2 and getVariable returns 100 when nil
	waitUntil { _plane getVariable ["ttt_nimitz_add", 100] isEqualTo 100 };
	_plane;
};


ttt_fnc_taxi = {
	params ["_plane", "_pos", "_sleep"];
	
	_plane setVariable ["ttt_nimitz_pos", _pos];
	_plane setVariable ["ttt_nimitz_sleep", _sleep];
	ttt_nimitz_taxi pushBackUnique _plane;

	waitUntil { count(_plane getVariable ["ttt_nimitz_pos", []]) isEqualTo 0 };
	_plane;
};

ttt_nimitz_fnc_taxiAndTakeoff = {
	params ["_carrier", "_plane", "_pos", "_catNr"];

	// does not work, pilots do not like to be moved around
	// createVehicleCrew _plane;

	private _prepPos = _pos getPos [10, (getDir _carrier) - 180];
	_prepPos set [2, getPosASL _plane # 2];
	[_plane, _plane getDir _prepPos] call ttt_nimitz_fnc_turn;
	sleep 0.5;
	[_plane, _prepPos, 0.01] call ttt_fnc_taxi;

	[_plane, _plane getDir _pos] call ttt_nimitz_fnc_turn;
	// _plane setDir (_plane getDir _pos);
	sleep 1;
	[_plane, _pos, 0.05] call ttt_fnc_taxi;

	// replace agents with AI
	{ _plane deleteVehicleCrew _x} forEach crew _plane;
	createVehicleCrew _plane;
	[_carrier, _plane, _catNr] spawn ttt_fnc_planeStart;
	// check if waypoint and alt assignment is better delayed after take off
	waitUntil {alive _plane and _plane distance _carrier > 200};
	[_plane] call ttt_nimitz_fnc_assignWaypoints;
	ttt_nimitz_planes_air pushBack _plane;
};

ttt_nimitz_fnc_flySAR = {
	params ["_sar", "_pos1", "_pos2"];
	createVehicleCrew _sar;
	_sar engineOn true;

	private _wp = (group driver _sar) addWaypoint [_pos1, 0];
	_wp setWaypointType "MOVE";
	_wp setWaypointSpeed "LIMITED";
	_wp = (group driver _sar) addWaypoint [_pos2, 0];
	_wp setWaypointType "CYCLE";

	while {alive _sar} do {
		// auto refuel, cheap way out
		_sar setFuel 1;
		sleep 600;
	};
};

ttt_nimitz_fnc_getOperationAlt = {
	private _base = 1000;
	private _inc = 100;

	if (isNil "ttt_nimitz_altFactor") then {
		ttt_nimitz_altFactor = 0;
	};

	private _alt = _base + (_inc * ttt_nimitz_altFactor);
	// systemChat format ["Sending alt %1", _alt];
	ttt_nimitz_altFactor = ttt_nimitz_altFactor + 1;
	_alt;
};

// naive flight path, left or right cycle around carrier
ttt_nimitz_fnc_assignWaypoints = {
	params ["_plane"];
	private _grp = group driver _plane;
	private _dir = getDir _plane;
	private _dirFactor = selectRandom [1, -1];
	private _wp = _grp addWaypoint [_plane getPos [5000, _dir], random 1000];
	_wp setWaypointType "MOVE";
	_wp setWaypointSpeed "LIMITED";
	_wp = _grp addWaypoint [_plane getPos [5000, _dir + (90 * _dirFactor)], random 1000];
	_wp setWaypointType "MOVE";
	_wp setWaypointSpeed "LIMITED";
	_wp = _grp addWaypoint [_plane getPos [5000, _dir + 180], random 1000];
	_wp setWaypointType "MOVE";
	_wp setWaypointSpeed "LIMITED";
	_wp = _grp addWaypoint [_plane getPos [5000, _dir + (270 * _dirFactor)], random 1000];
	_wp setWaypointType "CYCLE";
	_wp setWaypointSpeed "LIMITED";
	private _height = [] call ttt_nimitz_fnc_getOperationAlt;
	_plane flyInHeight 100;
	_plane flyInHeightASL [_height, _height, _height];

	_plane;
};

// Seems to be no longer used
ttt_fnc_landAndReplenishAndStart = {
	params ["_carrier", "_plane"];
	_plane setVariable ["ttt_nimitz_landingRequested", true];

	// we only land one plane at a time
	waitUntil { sleep(1 + random 1); alive _plane and _carrier getVariable ["ttt_nimitz_landing", false] };
	_carrier setVariable ["ttt_nimitz_landing", false];
	systemChat "Landing a plane";
	[_plane] spawn TTT_fnc_arrest;  
	_plane landAt (_carrier getVariable "JDG_dynamicAirportNimitz"); 

	waitUntil { isTouchingGround _plane and speed _plane < 10 and alive _plane };

	ttt_nimitz_planes_air = ttt_nimitz_planes_air - [_plane];
	{_plane deleteVehicleCrew _x} forEach crew _plane;
	_plane setVariable ["NimitzTailhook", nil];
	_plane animate ["tailhook", 0];
	private _nimspots = _carrier getVariable "nimspots";
	private _refuel = _nimspots modelToWorld (_nimspots selectionPosition "quarterMaster");

	private _pos = _refuel getPos [13, (getDir _carrier) - 90];
	_pos set [2, getPosASL _plane # 2];

	[_plane, _plane getDir _pos] call ttt_nimitz_fnc_turn;
	[_plane, _pos, 0.01] call ttt_fnc_taxi;
	[_plane] call ttt_nimitz_fnc_replenish;
	sleep 10;
	private _C1 = _nimspots modelToWorld (_nimspots selectionPosition "C1");
	private _C2 = _nimspots modelToWorld (_nimspots selectionPosition "C2");
	private _cat = [ [_C1, 1], [_C2, 2] ];
	private _catToUse = selectRandom _cat;
	[_carrier, _plane, _catToUse # 0, _catToUse # 1] call ttt_nimitz_fnc_taxiAndTakeoff;
	// release landing lock
	_carrier setVariable ["ttt_nimitz_landing", true];
	_plane setVariable ["ttt_nimitz_landingRequested", nil];
	_carrier;
};

ttt_nimitz_fnc_getParkEquipmentAndCrew = {
	params ["_carrier", "_pp"];
	private _cartName = format ["%1_cart", _pp];
	private _redName = format ["%1_red", _pp];
	private _grapeName = format ["%1_grape", _pp];
	private _whiteName = format ["%1_white", _pp];

	[_carrier getVariable [_cartName, ObjNull],
	 _carrier getVariable [_redName, ObjNull],
	 _carrier getVariable [_grapeName, ObjNull],
	 _carrier getVariable [_whiteName, ObjNull]
	];
};

ttt_nimitz_fnc_replenishAnimsStart = {
	params ["_cart", "_red", "_grape", "_white"];
	
	[_cart, 1] spawn ttt_nimitz_fnc_loadCart;
	{
		_x call BIS_fnc_ambientAnim__terminate;
	} forEach [ _red, _grape, _white ];
	[_red, "REPAIR_VEH_KNEEL", "ASIS"] call BIS_fnc_ambientAnim;
	[_grape, "REPAIR_VEH_STAND", "ASIS"] call BIS_fnc_ambientAnim;
	[_white, "BRIEFING", "ASIS"] call BIS_fnc_ambientAnim;
	["_cart", "_red", "_grape", "_white"];
};

ttt_nimitz_fnc_replenishAnimsEnd = {
	params ["_cart", "_red", "_grape", "_white"];
	
	{
		_x call BIS_fnc_ambientAnim__terminate;
	} forEach [ _red, _grape, _white ];
	[_red, "STAND_U1", "ASIS"] call BIS_fnc_ambientAnim;
	[_grape, "STAND_U2", "ASIS"] call BIS_fnc_ambientAnim;
	[_white, "STAND_U3", "ASIS"] call BIS_fnc_ambientAnim;

	["_cart", "_red", "_grape", "_white"];
};


ttt_nimitz_fnc_replenish = {
	params ["_plane", "_carrier", ["_parkPos", ""]];
	if (_parkPos isEqualTo "") then {
		"No parking pos supplied to ttt_nimitz_fnc_replenish, setting to pp1" call bis_fnc_error;
		_parkPos = "pp1";
	};
	private _parkEquipmentAndCrew = [_carrier, _parkPos] call ttt_nimitz_fnc_getParkEquipmentAndCrew;
	_parkEquipmentAndCrew call ttt_nimitz_fnc_replenishAnimsStart;
	_plane engineOn false;
	{
		_plane setPylonLoadOut [_x, "", true];
		sleep 1;
	} forEach ["pylon1", "pylon2", "pylon3", "pylon4", "pylon5", "pylon6", "pylon7", "pylon8", "pylon9", "pylon10", "pylon11"];
	sleep 5;
	[_parkEquipmentAndCrew # 0, 5] spawn ttt_nimitz_fnc_unloadCart;
	_plane setPylonLoadout ["pylon1", "PylonMissile_Missile_BIM9X_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon11", "PylonMissile_Missile_BIM9X_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon5", "PylonRack_Missile_AMRAAM_D_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon7", "PylonRack_Missile_AMRAAM_D_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon3", "PylonRack_Missile_AGM_02_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon9", "PylonRack_Missile_AGM_02_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon4", "PylonMissile_Bomb_GBU12_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon8", "PylonMissile_Bomb_GBU12_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon2", "PylonRack_Missile_AMRAAM_D_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon10", "PylonRack_Missile_AMRAAM_D_x1"];
	sleep 5;
	_plane setPylonLoadout ["pylon6", "js_m_fa18_wing_tank_x1"];
	sleep 5;
	_parkEquipmentAndCrew call ttt_nimitz_fnc_replenishAnimsEnd;
	_plane setFuel 1;
	_plane setVehicleAmmo 1;
	_plane setDamage 0;
	_plane;
};

// Unload weapons cart instantaneously
ttt_nimitz_fnc_unloadCart = {
	params ["_cart", ["_delay", 5]];
	{
		_cart animateSource [_x , 1];
		sleep _delay;
	} forEach [ "m8", "m6", "m7", "m5", "m4", "m1", "m2", "m3"];
	_cart;
};

ttt_nimitz_fnc_loadCart = {
	params ["_cart", ["_delay", 5]];
	{
		_cart animateSource [_x , 0];
		sleep _delay;
	} forEach [ "m2", "m3", "m1", "m4", "m5", "m7", "m6", "m8"];
	_cart;	
};

ttt_nimitz_fnc_deckboss_landingAllowed = {
	params ["_carrier"]	;
	private _ret = false;
	// systemChat format ["free PP %1, nimitz_landing %2",  _carrier getVariable ["ttt_nimitz_freePP", 0] , _carrier getVariable ["ttt_nimitz_landing", false]];
	// diag_log format ["free PP %1, nimitz_landing %2",  _carrier getVariable ["ttt_nimitz_freePP", 0] , _carrier getVariable ["ttt_nimitz_landing", false]];
	if (_carrier getVariable ["ttt_nimitz_freePP", 0] > 0 and _carrier getVariable ["ttt_nimitz_landing", false]) then {
		private _freePP = _carrier getVariable "ttt_nimitz_freePP";
		_carrier setVariable ["ttt_nimitz_freePP", _freePP - 1];
		_carrier setVariable ["ttt_nimitz_landing", false];
		_ret = true;
	};
	// systemChat format ["Deckboss: landing allowed %1", _ret];
	// systemChat format ["Deckboss: landing allowed %1", _ret];
	_ret;
};

ttt_nimitz_fnc_deckboss_assignParkPos = {
	params ["_carrier", "_plane"];
	private _ret = "";
	if (_carrier getVariable ["ttt_nimitz_pp1", false]) then {
		_ret = "pp1";
	};
	if (_carrier getVariable ["ttt_nimitz_pp2", false]) then {
		_ret = "pp2";
	};
	if (_carrier getVariable ["ttt_nimitz_pp3", false]) then {
		_ret = "pp3";
	};
	_carrier setVariable [format["ttt_nimitz_%1", _ret], false];
	if (_ret isEqualTo "") then {
		systemChat "WARN: ttt_nimitz_fnc_deckboss_assignParkPos _ret should not be empty string";
	};
	_ret;
};

Nimitz setVariable ["ttt_nimitz_pp1", true];
Nimitz setVariable ["ttt_nimitz_pp2", true];
Nimitz setVariable ["ttt_nimitz_pp3", true];
Nimitz setVariable ["ttt_nimitz_freePP", 3];
Nimitz setVariable ["ttt_nimitz_landing", true];
Nimitz setVariable ["ttt_nimitz_starting", true];

ttt_nimitz_fnc_wings = {
	params ["_plane", "_fold"];
	if (_plane isKindOf "JS_JC_FA18E" or _plane isKindOf "JS_JC_FA18F") then {
		_plane animate ["l_wingfold", _fold];
		_plane animate ["r_wingfold", _fold];
	};

	_plane;
};

ttt_nimitz_fnc_getPp = {
	params ["_carrier", "_parkPos"];
	private _nimspots = _carrier getVariable "nimspots";
	private _refuel = _nimspots modelToWorld (_nimspots selectionPosition "quarterMaster");

	private _pos = _refuel getPos [40, getDir _carrier - 40];

	if (_parkPos isEqualTo "pp2") then {
		_pos = _refuel getPos [25, getDir _carrier - 70];
	};

	if (_parkPos isEqualTo "pp3") then {
		_pos = _refuel getPos [25, getDir _carrier - 130];
	};
	_pos;
};

ttt_nimitz_fnc_landAndParkAndStart = {
	params ["_carrier", "_plane"];
	_plane setVariable ["ttt_nimitz_landingRequested", true];

	// we only land one plane at a time
	systemChat format ["Landing a plane: %1", _plane];
	[_plane] spawn TTT_fnc_arrest;  
	_plane landAt (_carrier getVariable "JDG_dynamicAirportNimitz"); 

	/**
	 * Stops the speed of the plane to 0 :(
	waitUntil { isTouchingGround _plane };
	// roughly turn the plane into the dir of the carrier, so it won't fall overboard
	private _dir = _plane getDir _carrier;
	[_plane, _dir] call ttt_nimitz_fnc_turn;
	 **/
	waitUntil { isTouchingGround _plane };	 
	// systemChat format ["%1 is plane dir, %2 is Carrier dir, diff if %3", getDir _plane, getDir _carrier, _plane getDir _carrier];
	while {alive _plane and speed _plane > 10} do {
		private _nextPos = _plane getPos [10, getDir _plane];
		// adjust for flight deck height
		_nextPos set [2, 18];
		private _intersects = lineIntersectsWith [_nextPos, [_nextPos # 0, _nextPos # 1, 0], _plane, objNull, false];
		// systemChat format ["%1 intersects", _intersects];
		if (count _intersects isEqualTo 0) then {
			systemChat "preventing splash";
			[_plane, _plane getDir _carrier] call ttt_nimitz_fnc_turn;
		};
		private _ent = _plane nearEntities 20;
		// systemChat str _ent;
		{
			if (_x isEqualTo _plane) exitWith {};
			private _type = toLower typeOf _x;
			if (_type find "jdg" > -1) exitWith {};
			systemChat format ["preventing crash with %1 [%2]", _x, _type];
			[_plane, _plane getDir _carrier] call ttt_nimitz_fnc_turn;
		} forEach _ent;
		sleep 0.01;
	};
	// wait for arrest to haven taken out the speed
	waitUntil { isTouchingGround _plane and speed _plane < 10 };
	// if (!alive _plane) exitWith {
	// 	_carrier setVariable ["ttt_nimitz_landing", true];
	// 	private _freePP = _carrier getVariable "ttt_nimitz_freePP";
	// 	_carrier setVariable ["ttt_nimitz_freePP", _freePP + 1];
	// };
	ttt_nimitz_planes_air = ttt_nimitz_planes_air - [_plane];

	// Replace AI with agents, as they hopefully won't interfere with the taxi script
	{
		private _type = typeOf _x;
		_plane deleteVehicleCrew _x;
		private _agent = createAgent [_type, getPosATL _plane, [], 0, "FORM"];
		_agent moveInAny _plane;
	} forEach crew _plane;
	// {_plane deleteVehicleCrew _x} forEach crew _plane;

	_plane setVariable ["NimitzTailhook", nil];
	_plane animate ["tailhook", 0];
	[_plane, 1] spawn ttt_nimitz_fnc_wings;
	private _parkPos = [_carrier, _plane] call ttt_nimitz_fnc_deckboss_assignParkPos;
	
	private _pos = [_carrier, _parkPos] call ttt_nimitz_fnc_getPp;
	_pos set [2, getPosASL _plane # 2];

	private _taxiPos = _pos getPos [30, getDir _carrier - 90];
	_taxiPos set [2, getPosASL _plane # 2];
	[_plane, _plane getDir _taxiPos] call ttt_nimitz_fnc_turn;
	[_plane, _taxiPos, 0.01] call ttt_fnc_taxi;

	[_plane, _plane getDir _pos] call ttt_nimitz_fnc_turn;
	[_plane, _pos, 0.02] call ttt_fnc_taxi;

	_carrier setVariable ["ttt_nimitz_landing", true];
	private _pilot = driver _plane;
	_pilot action ["getOut", _plane];
	waitUntil {!(_pilot in _plane)};
	sleep 5;
	[_plane, _carrier, _parkPos] call ttt_nimitz_fnc_replenish;
	sleep 90;
	_pilot action ["getInPilot", _plane];
	waitUntil {_pilot in _plane};
	sleep 5;
	systemChat format ["Ready to start! %1", _plane getVariable ["ttt_nimitz_callsign", "Vader"]];

	waitUntil { [_carrier, _plane] call ttt_nimitz_fnc_deckboss_startingAllowed };
	if (!alive _plane) exitWith {
		_carrier setVariable [format["ttt_nimitz_%1", _parkPos], true];
		private _freePP = _carrier getVariable "ttt_nimitz_freePP";
		_carrier setVariable ["ttt_nimitz_freePP", _freePP + 1];
		_carrier setVariable ["ttt_nimitz_starting", true];
	};

	systemChat format ["Plane starting %1", _plane getVariable ["ttt_nimitz_callsign", "Vader"]];
	_plane engineOn true;
	private _cat = _carrier getVariable "ttt_nimitz_catToUse";
	// taxi first
	_taxiPos = _plane getPos [15, getDir _carrier + 90];
	_taxiPos set [2, getPosASL _plane # 2];
	[_plane, _plane getDir _taxiPos] call ttt_nimitz_fnc_turn;
	[_plane, _taxiPos, 0.02] call ttt_fnc_taxi;
	sleep 1;
	// Release park place
	_carrier setVariable [format["ttt_nimitz_%1", _parkPos], true];
	private _freePP = _carrier getVariable "ttt_nimitz_freePP";
	_carrier setVariable ["ttt_nimitz_freePP", _freePP + 1];

	private _nimspots = _carrier getVariable "nimspots";
	private _E1 = _nimspots modelToWorld (_nimspots selectionPosition "E1");
	_taxiPos = _E1 getPos [10, getDir _carrier];
	_taxiPos set [2, getPosASL _plane # 2];
	[_plane, _plane getDir _taxiPos] call ttt_nimitz_fnc_turn;
	[_plane, _taxiPos, 0.01] call ttt_fnc_taxi;
	[_plane, 0] spawn ttt_nimitz_fnc_wings;
	[_carrier, _plane, _cat # 0, _cat # 1] call ttt_nimitz_fnc_taxiAndTakeoff;

	(group driver _plane) setGroupId [_plane getVariable ["ttt_nimitz_callsign", "Vader"]];
	_plane setVariable ["ttt_nimitz_landingRequested", nil];
	_carrier setVariable ["ttt_nimitz_starting", true];
	_carrier;
};

ttt_nimitz_fnc_deckboss_startingAllowed = {
	params ["_carrier", "_plane"];
	private _ret = false;
	if (_carrier getVariable ["ttt_nimitz_starting", false]) then {
		private _nimspots = _carrier getVariable "nimspots";
		private _C1 = _nimspots modelToWorld (_nimspots selectionPosition "C1");
		private _C2 = _nimspots modelToWorld (_nimspots selectionPosition "C2");

		private _cat = [ [_C1, 1], [_C2, 2] ];
		// private _cat = [ [_C1, 1] ];
		private _catToUse = selectRandom _cat;
		// side effect!
		_carrier setVariable ["ttt_nimitz_catToUse", _catToUse];
		_carrier setVariable ["ttt_nimitz_starting", false];
		_ret = true;
	};
	_ret;
};


ttt_nimitz_fnc_createCartsAndCrew = {
	params ["_carrier"];
	private _type = "ttt_weaponscart";
	private _nimspots = _carrier getVariable "nimspots";
	private _refuel = _nimspots modelToWorld (_nimspots selectionPosition "quarterMaster");

	{
		private _parkPos = [Nimitz, _x] call ttt_nimitz_fnc_getPp;
		// move slightly on board
		private _pos = _parkPos getPos [-10, getDir _carrier];
		// flightdeck height roughly
		_pos set [2, 17.5];
		private _cart = createVehicle [_type, _pos, [], 0, "NONE"];
		_cart setPosASL _pos;
		_cart setDir (getDir _carrier + 90);
		[_cart, 0] call ttt_nimitz_fnc_unloadCart;

		private _name = format ["%1_cart", _x];
		_carrier setVariable [_name, _cart];
		// short delay so the position of cart and especially ASL height is set
		sleep 1;
		_pos = _cart getPos [2.4, (getDir _carrier) + 90];
		private _agent = createAgent [ttt_nimitz_soldierTypes # RED, _pos, [], 0, "NONE"];
		_agent setPosASL [getPos _agent # 0, getPos _agent # 1, getPosASL _cart # 2];
		_agent setDir (getDir _carrier - 90);
		[_agent, "STAND_U1", "ASIS"] call BIS_fnc_ambientAnim;
		_name = format ["%1_red", _x];
		_carrier setVariable [_name, _agent];

		_pos = _cart getPos [2.4, (getDir _carrier) - 75];
		_agent = createAgent [ttt_nimitz_soldierTypes # GRAPE, _pos, [], 0, "NONE"];
		_agent setPosASL [getPos _agent # 0, getPos _agent # 1, getPosASL _cart # 2];
		_agent setDir (getDir _carrier + 90);
		[_agent, "STAND_U2", "ASIS"] call BIS_fnc_ambientAnim;
		_name = format ["%1_grape", _x];
		_carrier setVariable [_name, _agent];

		_pos = _cart getPos [-1, getDir _carrier];
		_agent = createAgent [ttt_nimitz_soldierTypes # WHITE, _pos, [], 0, "NONE"];
		_agent setPosASL [getPos _agent # 0, getPos _agent # 1, getPosASL _cart # 2];
		_agent setDir (getDir _carrier);
		[_agent, "STAND_U3", "ASIS"] call BIS_fnc_ambientAnim;
		_name = format ["%1_white", _x];
		_carrier setVariable [_name, _agent];

	} forEach [ "pp1", "pp2", "pp3" ];
};


[] spawn {
	sleep 1;
	[Nimitz] spawn ttt_nimitz_fnc_createCartsAndCrew;
	// sleep 1;
	// {
	// 	private _parkPos = [Nimitz, _x] call ttt_nimitz_fnc_getPp;
	// 	private _plane = createVehicle ["JS_JC_FA18E", _parkPos, [], 0, "NONE"];
	// 	_plane setPosASL [getPos _plane # 0, getPos _plane # 1, 17.5];
	// 	_plane setDir (getDir Nimitz + 90);
	// } forEach [ "pp1", "pp2", "pp3" ];


	sleep 5;
	
	private _nr = 1;
	while {time > 0} do {
		{
			if ( (_x getVariable ["ttt_marker", ""]) isEqualTo "" ) then {
				private _mrkr = createMarker [str _nr, _x];
				_nr = _nr + 1;
				_mrkr setMarkerType "b_plane";
				_mrkr setMarkerColor "ColorBlue";
				_mrkr setMarkerText format ["%3: a-%1 f-%2", floor(getPosASL _x # 2), floor(fuel _x * 100), groupId group driver _x];
				_x setVariable ["ttt_marker", _mrkr];
			} else {
				private _mrkr = _x getVariable "ttt_marker";
				_mrkr setMarkerPos (getPos _x);
				_mrkr setMarkerText format ["%3: a-%1 f-%2", floor(getPosASL _x # 2), floor(fuel _x * 100), groupId group driver _x];
				if (!alive _x) then {
					_mrkr setMarkerColor "ColorBlack";
				};
			};

			// land and rearm when fuel is low
			// if (fuel _x < 0.95 and 	!(_x getVariable ["ttt_nimitz_landingRequested", false])) then {
			// 	[Nimitz, _x] spawn ttt_fnc_landAndReplenishAndStart;
			// };
			if (alive _x and {fuel _x < 0.95} and {!(_x getVariable ["ttt_nimitz_landingRequested", false])} and {[Nimitz] call ttt_nimitz_fnc_deckboss_landingAllowed}) then {
				// systemChat format ["Requesting to land and park %1", groupId group driver _x];
				diag_log format ["Requesting to land and park %1", groupId group driver _x];
				[Nimitz, _x] spawn ttt_nimitz_fnc_landAndParkAndStart;
			};
		} forEach ttt_nimitz_planes_air;
		sleep 0.1;
	};
};

[] execVM "INDICAM\indiCam_core_init.sqf";